import { useEffect, useState } from "react";
import "./App.css";
import Layout from "./components/base/layout";
import Form from "./components/top-level/form";
import Tasks from "./components/top-level/tasks";
import {
  addTodo,
  getTodo,
  updateRemainder,
  updateTitle,
  deleteTodo,
} from "./lib/api";

function App() {
  const [task, setTask] = useState([]);
  const addtask = async (data) => {
    const todoData = await addTodo(data);
    setTask([...task, todoData]);
  };
  const gettask = async () => {
    const todoData = await getTodo();
    setTask(todoData);
  };

  const updateremainder = async (id) => {
    const todoData = await updateRemainder(id);
    setTask(
      task.map((e) =>
        e.id === todoData.id ? { ...e, isCompleted: todoData.isCompleted } : e
      )
    );
  };

  const updatetitle = async (data) => {
    const todoData = await updateTitle(data);
    setTask(task.map((e) => (e.id === todoData.id ? todoData : e)));
  };

  const deletetask = async (id) => {
    await deleteTodo(id);
    setTask(task.filter((e) => e.id !== id));
  };

  // const getTask = async () => {
  //   const taskData = await fetch("http://192.168.1.91:5000/task");
  //   const response = await taskData.json();
  //   setTask(response);
  // };
  // const getTaskById = async (id) => {
  //   const tasktracker = await fetch(`http://192.168.1.91:5000/task/${id}`);
  //   const response = await tasktracker.json();
  //   return response;
  // };
  // const remainder = async (id) => {
  //   const toogle = await getTaskById(id);
  //   const result = { ...toogle, isCompleted: !toogle.isCompleted };

  //   const res = await fetch(`http://192.168.1.91:5000/task/${id}`, {
  //     method: "PUT",
  //     headers: { "Content-type": "application/json" },
  //     body: JSON.stringify(result),
  //   });
  //   const data = await res.json();
  //   setTask(
  //     task.map((e) =>
  //       e.id === data.id ? { ...e, isCompleted: data.isCompleted } : e
  //     )
  //   );
  // };
  // const editTask = async (datas) => {
  //   console.log(datas);
  //   const response = await fetch(`http://192.168.1.91:5000/task/${datas.id}`, {
  //     method: "PATCH",
  //     headers: { "Content-type": "application/json" },
  //     body: JSON.stringify({ title: datas.title }),
  //   });

  //   const data = await response.json();

  //   setTask(task.map((e) => (e.id === data.id ? data : e)));
  // };

  // const deleteTask = async (id) => {
  //   await fetch(`http://192.168.1.91:5000/task/${id}`, {
  //     method: "DELETE",
  //   });
  //   setTask(task.filter((e) => e.id !== id));
  // };
  useEffect(() => {
    gettask();
  }, []);

  return (
    <div className="App">
      <Layout count={task.filter((e) => !e.isCompleted).length}>
        {task.length > 0 ? (
          <Tasks
            tasklist={task}
            onEdit={updatetitle}
            remainder={updateremainder}
            deleted={deletetask}
          />
        ) : (
          <h3>No task</h3>
        )}
        <Form onSubmit={addtask} />
      </Layout>
    </div>
  );
}

export default App;
